'use strict';

// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', [
   'ionic',
   'ionic.cloud',
   'ngCordova',
   //'ionic.service.core',
   //'ionic.service.analytics',
   'starter.controllers'
])

.config(function($ionicCloudProvider) {
   $ionicCloudProvider.init({
      "core": {
         "app_id": "c485b2c4"
      }
   });
})

.run(function($ionicPlatform, $ionicDeploy){
   $ionicPlatform.ready(function() {
      
      console.log('ionicPlatform.ready');

      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins.Keyboard) {
         cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false); //(true);
         cordova.plugins.Keyboard.disableScroll(true);
      }
      if (window.StatusBar) {
         // org.apache.cordova.statusbar required
         StatusBar.styleDefault();
      }


      setTimeout(function(){
         // Deploy
         console.log('looking for updates...');

         $ionicDeploy.getSnapshots().then(function(snapshots){
            console.log('snapshots list', snapshots);
            // snapshots will be an array of snapshot uuids
         });

         // check available updates
         $ionicDeploy.check().then(function(snapshotAvailable){
            console.log('new update available!', snapshotAvailable);
            // When snapshotAvailable is true, you can apply the snapshot
            if(snapshotAvailable){
               $ionicDeploy.download().then(function(){
                  console.log('downloaded new update, extracting...');
                  return $ionicDeploy.extract().then(function(){
                     console.log('reloading app to finish installation');
                     $ionicDeploy.load();
                  })
               });   
            }
         });
      }, 500);

      /*
      //lock to portrait on mobiles
      if (screen.width <= 720) {
         screen.lockOrientation('portrait-primary');
      } else {
         screen.lockOrientation('landscape-primary');
      }
      */

      // Firebase Analytics
      //setTimeout(function(){
         console.log(window.FirebasePlugin);
         console.log('Firebase Analytics')
         if(typeof window.FirebasePlugin !== "undefined"){
            window.FirebasePlugin.logEvent("page_view", { page: "Categories" });
         } else {
            console.log("Firebase Analytics Unavailable");
         }
      //}, 4000);

      // Google Analytics
      //setTimeout(function(){
         console.log(window.ga);
         console.log('Google Analytics')
         if(typeof window.ga !== "undefined"){
            // window.ga.debugMode();
            window.ga.startTrackerWithId('UA-82059581-2');
            window.ga.trackView('Categories', '', true);
            window.ga.setAppVersion('0.3.1');
         } else {
            console.log("Google Analytics Unavailable");
         }
      //}, 5000);

      /*
      if(window.Connection) {
         if(navigator.connection.type == Connection.NONE) {
            window.alert('There is no internet connection available');
         } else {
            window.alert(navigator.connection.type);
         }
      } else {
         window.alert('Cannot find Window.Connection');
      }
      */

      //window.alert('width: ' + screen.width + ' / height: ' + screen.height);

      //var currentPlatform = ionic.Platform.platform();
      //alert(currentPlatform);
      //var isWebView = ionic.Platform.isWebView();
      //alert(isWebView);
  });
})

/*
.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})
*/

//.config(function($stateProvider, $httpProvider, $urlRouterProvider, $cordovaInAppBrowserProvider) {
.config(function($stateProvider, $httpProvider, $urlRouterProvider) {

   /*
   var defaultOptions = {
      location: 'no',
      clearcache: 'no',
      toolbar: 'no'
   };

   document.addEventListener(function () {
      //$cordovaInAppBrowserProvider.setDefaultOptions(options);
      $cordovaInAppBrowserProvider.setDefaultOptions(defaultOptions);
   }, false);
   */

   /*
   $httpProvider.defaults.useXDomain = true;
   $httpProvider.defaults.withCredentials = true;
   delete $httpProvider.defaults.headers.common['X-Requested-With'];
   //$httpProvider.defaults.headers.common = 'Content-Type: application/json';
   //$httpProvider.defaults.headers.common = 'Content-Type: text/html,application/xhtml+xml,application/xml';   
   $httpProvider.defaults.headers.get = {
      'Access-Control-Allow-Origin'  : '*',
      'Access-Control-Allow-Methods' : 'GET, OPTIONS',
      'Access-Control-Allow-Headers' : 'Origin, X-Requested-With, Content-Type, Accept',
      'Content-Type' : 'application/json'
   };
   */

   $stateProvider

   .state('app', {
      url: '/app',
      cache: false,
      abstract: true,
      templateUrl: 'templates/menu.html',
      controller: 'AppCtrl'
   })

      .state('intro', {
         url: '/',
         templateUrl: 'templates/intro.html',
         controller: 'IntroCtrl'
      })
      /*
      .state('main', {
         url: '/main',
         templateUrl: 'templates/main.html',
         controller: 'MainCtrl'
      })
      */
      
   /*
   .state('app.search', {
      url: '/search',
      views: {
         'menuContent': {
            templateUrl: 'templates/search.html'
         }
      }
   })
   .state('app.browse', {
      url: '/browse',
      views: {
         'menuContent': {
            templateUrl: 'templates/browse.html'
         }
      }
   })
   */

   .state('app.categories', {
      url: '/categories',
      views: {
         'menuContent': {
            templateUrl: 'templates/categories.html',
            controller: 'CategoriesCtrl'
         }
      }
   })
   .state('app.single', {
      url: '/categories/:categoryId/:categoryName',
      views: {
         'menuContent': {
            templateUrl: 'templates/category.html',
            controller: 'CategoryCtrl'
         }
      }
   })
   .state('app.formula', {
      url: '/formula/:formulaId/:formulaIndex',
      cache: false,
      views: {
         'menuContent': {
            templateUrl: 'templates/formula.html',
            //templateUrl: 'templates/formula/' + $stateParams.formulaId + '.html',
            controller: 'FormulaCtrl'
         }
      }
   })
      /*
      .state('app.abcd2', {
         url: '/formula/abcd2',
            views: {
               'menuContent': {
                  templateUrl: 'templates/formulas/abcd2.html'
            }
         }
      })
      */

   .state('app.contact', {
      url: '/contact',
      views: {
         'menuContent': {
            templateUrl: 'templates/contact.html'
         }
      }
   });

   /*
   .state('app.playlists', {
      url: '/playlists',
      views: {
         'menuContent': {
            templateUrl: 'templates/playlists.html',
            controller: 'PlaylistsCtrl'
         }
      }
   })
   .state('app.single', {
      url: '/playlists/:playlistId',
      views: {
         'menuContent': {
            templateUrl: 'templates/playlist.html',
            controller: 'PlaylistCtrl'
         }
      }
   });
   */

   // if none of the above states are matched, use this as the fallback
   //$urlRouterProvider.otherwise('/app/playlists');
   $urlRouterProvider.otherwise('/');
});
